
Ruby - Bug #5076

Mac OS X Lion Support 

07/22/2011 08:20 PM - naruse (Yui NARUSE)

Status: Closed   

Priority: Normal   

Assignee:    

Target version: 1.9.4   

ruby -v: - Backport:  

Description

Ruby doesn't work on Lion.

Subtasks:

Bug # 5031: Enumerable#zip SEGFAULTs with a Range Object (Mac OS X 10.7 LION) Closed

Bug # 5078: test-all make SystemStackError on OS X 10.7 (Lion) Closed

Bug # 5081: LionでTestSyslog が一件 failure Closed

Bug # 5082: test_context_switch(TestMarshal) was failed on OS X 10.7 (Lion) Closed

Bug # 4501: 1.9.2-p180 fails to compile on OSX 10.7 Closed

Bug # 5122: make test fails on OS X 10.7 (11A511) Closed

Bug # 5201: Ruby 1.9.2p290 [x86_64-darwin11.0.0] Fiber.yieldでSEGV Third Party's Issue

Bug # 5433: PTY.spawn Kernel panic on macos lion Third Party's Issue

Related issues:

Related to Ruby - Bug #4944: crash in FIPS mode after unchecked EVP_DigestIni... Closed 06/29/2011

Related to Ruby - Bug #5933: thin と Rack::FiberPool で SEGV が発生 Closed 01/26/2012

Related to Ruby - Bug #7817: (Unable to compile Ruby 2.0.0-rc2 on OSX (clang ... Rejected 02/10/2013

Has duplicate Ruby - Bug #5181: yard causes Ruby 1.9.2 crash on Mac OS X Lion... Closed 08/10/2011

Associated revisions

Revision 5975e9e0 - 07/22/2011 12:52 PM - kosaki (Motohiro KOSAKI)

vm_insnhelper.c (vm_call_cfunc): added volatile for a workaround

of cfp consistency error problem on OS X 10.7 (Lion). It's

suspected llvm optimization bug.

[Bug #5076] [ruby-dev:44185]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@32628 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision b44970a0 - 07/22/2011 12:53 PM - kosaki (Motohiro KOSAKI)

merge revision(s) 32628:

    * vm_insnhelper.c (vm_call_cfunc): added volatile for a workaround

      of cfp consistency error problem on OS X 10.7 (Lion). It's

      suspected llvm optimization bug.

      [Bug #5076] [ruby-dev:44185]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_9_3@32629 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 07/22/2011 09:52 PM - kosaki (Motohiro KOSAKI)

- Status changed from Open to Closed

- % Done changed from 33 to 100

This issue was solved with changeset r32628.

Yui, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.
vm_insnhelper.c (vm_call_cfunc): added volatile for a workaround

of cfp consistency error problem on OS X 10.7 (Lion). It's

suspected llvm optimization bug.

[Bug #5076] [ruby-dev:44185]

#2 - 07/22/2011 09:59 PM - kosaki (Motohiro KOSAKI)

- Status changed from Closed to Open

すいません、コミットするときに参照するバグ番号を間違えたようです。reopenします

#3 - 07/24/2011 01:46 AM - kosaki (Motohiro KOSAKI)

備忘録として。むらけんのさんのくーるパッチ r32649 によってクラッシュバグは #5081 (syslogのフォーマット変更）以外のfaulureは消えたので、もうLion対応は1.9.3

のblockerではありません。1.9.4までに作業すればよい状況です。

#4 - 08/08/2011 12:17 AM - kosaki (Motohiro KOSAKI)

- Target version changed from 1.9.3 to 1.9.4

Now, r32649 provides us a very nice workaround. Then, we can slip this ticket to 1.9.4.

#5 - 08/11/2011 02:21 AM - yesmar (Ramsey Dow)

Although bug #5181 was closed as a dup, yard 0.7.2 crashing on Lion is apparently just a part of a larger problem. yard also crashes on Mac OS X

10.6.8 (Snow Leopard) with the same version of Ruby and RubyGems (1.9.2-p290 and 1.8.7, respectively).

#6 - 09/06/2011 05:27 PM - naruse (Yui NARUSE)

下記の通り Github にてコミットへのコメントとして、Xcode 4.2 Developer Preview 7 において、

付録の LLVM/clang が更新され、trunk の test-all が通るようになっています。

同時に gcc-4.2 の添付が終了しているようなんですが（こっちはすでに入ってたので未確認）どうしましょうか。

https://github.com/ruby/ruby/commit/ddcb133aa22bf0be31baeea0787369671c689b74

"Apple clang version 3.0 (tags/Apple/clang-211.9) (based on LLVM 3.0svn)"

#7 - 09/06/2011 09:37 PM - kosaki (Motohiro KOSAKI)

- Status changed from Open to Closed

- % Done changed from 71 to 100

This issue was solved with changeset r32629.

Yui, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.

merge revision(s) 32628:

* vm_insnhelper.c (vm_call_cfunc): added volatile for a workaround

  of cfp consistency error problem on OS X 10.7 (Lion). It's

  suspected llvm optimization bug.

  [Bug #5076] [ruby-dev:44185]

#8 - 09/07/2011 08:00 AM - kosaki (Motohiro KOSAKI)

- Status changed from Closed to Open

あれ、見に覚えがないのにcloseされてる。再度 openします。

ええと、間にあうなら1.9.3p0に入れるべきだと思いますが、わたしは時間が取れません

#9 - 09/07/2011 10:42 AM - naruse (Yui NARUSE)

Motohiro KOSAKI wrote:

あれ、見に覚えがないのにcloseされてる。再度 openします。

ええと、間にあうなら1.9.3p0に入れるべきだと思いますが、わたしは時間が取れません

 ええと、事は単純じゃなくてですね、

Xcode 4.1 環境の場合: gcc (llvm-gcc) だとダメ、gcc-4.2 なら OK

Xcode 4.2 環境の場合: gcc  (llvm-gcc) でも動く模様、gcc-4.2 がない、まだベータ
ってかんじなのです。

#10 - 09/07/2011 12:54 PM - mrkn (Kenta Murata)

gcc -v の出力内容を見て振り分けるしかやりようがない気がします。

#11 - 09/07/2011 12:56 PM - mrkn (Kenta Murata)

よく考えてみると、単純に「gcc-4.2 が存在していたら gcc-4.2 を使う」というやり方で良さそうです。如何でしょう？

これで問題なさそうなら、今夜にでも patch を書いて直してしまおうと思います。

#12 - 09/07/2011 01:23 PM - shyouhei (Shyouhei Urabe)

バグってるコンパイラをサポートし続ける意味が分からない。

193p0に関してはXCode4.2を使えとでもリリースアナウンスに書いときゃそれでいいでしょう。

#13 - 09/07/2011 05:10 PM - naruse (Yui NARUSE)

Shyouhei Urabe wrote:

バグってるコンパイラをサポートし続ける意味が分からない。

193p0に関してはXCode4.2を使えとでもリリースアナウンスに書いときゃそれでいいでしょう。

 わたしもこちら側の考えで、入れた hack の全 revert でいいんじゃないかと思っています。

#14 - 09/07/2011 06:48 PM - mrkn (Kenta Murata)

なるほど、そうですね。

では、XCode 4.2 が正式にリリースされたら revert することにします。

#15 - 09/07/2011 07:05 PM - naruse (Yui NARUSE)

Kenta Murata wrote:

なるほど、そうですね。

では、XCode 4.2 が正式にリリースされたら revert することにします。

 Xcode 4.2 の正式リリースより 1.9.3 のリリースの方が多分先です

#16 - 09/07/2011 11:53 PM - kosaki (Motohiro KOSAKI)

- ruby -v changed from trunk to -

2011/9/7 Yui NARUSE naruse@airemix.jp:

Issue #5076 has been updated by Yui NARUSE.

Kenta Murata wrote:

なるほど、そうですね。

では、XCode 4.2 が正式にリリースされたら revert することにします。

 Xcode 4.2 の正式リリースより 1.9.3 のリリースの方が多分先です

 了解. revertに同意します

#17 - 09/08/2011 11:41 AM - sorah (Sorah Fukumori)

Hi,

I've tested ruby with Xcode 4.2 Developer Preview 7.

Test results are below:

llvm-gcc with optflags="-O3"

build succeeded

test-all (with TESTS="-j") fails by parallel.rb (worker process) crashes with "[BUG] Bus Error"

test-all (without TESTS="-j") fails by SystemStackError "stack level too deep"
At the build process, I saw some deprecated warnings at openssl. Sorry I missed taking the log.

clang with optflags="-O3"

build succeeded

test-all (with TESTS="-j") runs successfully.

I forgot to check deprecated warnings at openssl...

Yui said at [ruby-core:39316] that:

Xcode 4.2 環境の場合: gcc  (llvm-gcc) でも動く模様、gcc-4.2 がない、まだベータ

(Translated:)

At the Xcode 4.2 environment: Ruby seems work at gcc (llvm-gcc). There is no gcc-4.2. Still in Beta

 As I tested with Xcode 4.2 + llvm-gcc, test-all wasn't passed in my environment :p

-- Japanese below...

Xcode 4.2 Developer Preview 7 でのテスト結果をお知らせします:

llvm-gcc with optflags="-O3"

build は通る

test-all (with -j) は [BUG] Bus Error で parallel.rb が死ぬ

test-all (without -j) はテストの途中でstack level too deep

ビルド時にopenssl周りで大量のdeprecatedが出ていたきがする．ログは取りのがした．

clang with optflags="-O3"

build は通る

test-all (with -j) は何事も無く完走

openssl周りのdeprecatedがあったかどうかは未確認．

なるせさんが [ruby-core:39316] で

Xcode 4.2 環境の場合: gcc  (llvm-gcc) でも動く模様、gcc-4.2 がない、まだベータ

 のような事を言っていましたが，手元の環境ではllvm-gccでtest-all完走しなかった…

As I tested with Xcode 4.2 + llvm-gcc, test-all wasn't passed in my environment :p

誰も気づいていなかったようだけど，ruby-coreに大量の日本語が…

#18 - 02/10/2012 05:45 PM - naruse (Yui NARUSE)

- Status changed from Open to Closed

From r34278, ruby-trunk should support Lion with following clang:

% clang --version

Apple clang version 3.0 (tags/Apple/clang-211.10.1) (based on LLVM 3.0svn)

Target: x86_64-apple-darwin11.3.0

Thread model: posix
